Index: sources/app/src/main/java/parkup/services/VrabotenService.java
===================================================================
--- sources/app/src/main/java/parkup/services/VrabotenService.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/services/VrabotenService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -3,7 +3,7 @@
 import java.time.LocalDateTime;
 import java.util.*;
+import java.util.stream.Collectors;
 import javax.transaction.Transactional;
 import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.data.jpa.repository.Modifying;
 import org.springframework.security.core.userdetails.UserDetails;
 import org.springframework.security.core.userdetails.UserDetailsService;
@@ -13,5 +13,8 @@
 import parkup.configs.token.ConfirmationTokenW;
 import parkup.configs.token.ConfirmationTokenService;
+import parkup.data.enumarations.EmployeeStatus;
+import parkup.entities.ParkingZone;
 import parkup.entities.Vraboten;
+import parkup.repositories.ParkingZoneRepository;
 import parkup.repositories.VrabotenRepository;
 import parkup.data.VrabotenDemo;
@@ -20,10 +23,12 @@
 public class VrabotenService implements UserDetailsService {
     private final VrabotenRepository vrabotenRepository;
+    private final ParkingZoneRepository parkingZoneRepository;
     private final BCryptPasswordEncoder bCryptPasswordEncoder;
     private final ConfirmationTokenService confirmationTokenService;
 
     @Autowired
-    public VrabotenService(VrabotenRepository vrabotenRepository, BCryptPasswordEncoder bCryptPasswordEncoder, ConfirmationTokenService confirmationTokenService) {
+    public VrabotenService(VrabotenRepository vrabotenRepository, ParkingZoneRepository parkingZoneRepository, BCryptPasswordEncoder bCryptPasswordEncoder, ConfirmationTokenService confirmationTokenService) {
         this.vrabotenRepository = vrabotenRepository;
+        this.parkingZoneRepository = parkingZoneRepository;
         this.bCryptPasswordEncoder = bCryptPasswordEncoder;
         this.confirmationTokenService = confirmationTokenService;
@@ -43,5 +48,5 @@
         List<VrabotenDemo> vrabotenDemos = new ArrayList<>();
         for (Vraboten v : vraboteni){
-            VrabotenDemo vd = new VrabotenDemo(v.getFirstName(), v.getLastName(), v.getEmail());
+            VrabotenDemo vd = new VrabotenDemo(v.getVrabotenId(),v.getFirstName(), v.getLastName(), v.getEmail());
             vrabotenDemos.add(vd);
         }
@@ -49,56 +54,128 @@
     }
 
-    public Optional<Vraboten> addVraboten(Vraboten vraboten) {
-        Optional<Vraboten> vrabotenOpt = this.vrabotenRepository.findVrabotenByEmail(vraboten.getEmail());
-        if (vrabotenOpt.isPresent()) {
-            throw new IllegalStateException("Email already taken, try adding a vraboten with a different valid email address");
+    public Optional<Vraboten> addVraboten(String password,String confirmPass,boolean locked, String firstName, String lastName, String mobile, String email, EmployeeStatus status,List<String> parkingZones) {
+        Optional<Vraboten> vrabotenOpt = this.vrabotenRepository.findVrabotenByEmail(email);
+        if (vrabotenOpt.isPresent()){
+            throw new IllegalArgumentException("User with that mail already exists");
+        }
+        Vraboten vrabotenToAdd=new Vraboten();
+        if (email != null && email.length() > 1 && email.contains("@") ) {
+            vrabotenToAdd.setEmail(email);
         } else {
-            if (vraboten.getEmail() != null && vraboten.getEmail().length() > 1 && vraboten.getEmail().contains("@")) {
-                //System.out.println(vraboten);
-                this.vrabotenRepository.save(vraboten);
-            }
-            else{
-                throw new IllegalStateException("email not valid");
-            }
-        }
-        return vrabotenOpt;
+            throw new IllegalStateException("email not valid");
+        }
+        if(password.equals(confirmPass)){
+            vrabotenToAdd.setPassword(bCryptPasswordEncoder.encode(password));
+        }
+        vrabotenToAdd.setLocked(locked);
+
+        if (firstName != null && firstName.length() > 1) {
+            vrabotenToAdd.setFirstName(firstName);
+        }
+
+        if (lastName != null && lastName.length() > 1 ) {
+            vrabotenToAdd.setLastName(lastName);
+        }
+
+        if (mobile != null && mobile.length() > 0 ) {
+            vrabotenToAdd.setMobile(mobile);
+        }
+
+        vrabotenToAdd.setStatus(status);
+
+        if(parkingZones!=null){
+            List<ParkingZone> parkingZonesAvailable =parkingZoneRepository.findAll();
+            List<ParkingZone> zonesToAdd= new ArrayList<>();
+            vrabotenToAdd.setParkingZones(null);
+            for(String pzName:parkingZones){
+                for(ParkingZone pz :parkingZonesAvailable){
+                    if(pzName.equals(pz.getPzName())) {
+                        zonesToAdd.add(pz);
+//                            pz.getOdgovorniLica().add(vrabotenRepository.findByVrabotenId(vrabotenId));
+                    }
+                }
+            }
+            vrabotenToAdd.setParkingZones(zonesToAdd);
+        }
+        String token = UUID.randomUUID().toString();
+        ConfirmationTokenW confirmationTokenW = new ConfirmationTokenW(
+                token,
+                LocalDateTime.now(),
+                LocalDateTime.now().plusMinutes(15),
+                vrabotenToAdd
+        );
+
+        confirmationTokenService.saveConfirmationTokenW(confirmationTokenW);
+
+        return Optional.of(vrabotenToAdd);
+//        Optional<Vraboten> vrabotenOpt = this.vrabotenRepository.findVrabotenByEmail(vraboten.getEmail());
+//        if (vrabotenOpt.isPresent()) {
+//            throw new IllegalStateException("Email already taken, try adding a vraboten with a different valid email address");
+//        } else {
+//            if (vraboten.getEmail() != null && vraboten.getEmail().length() > 1 && vraboten.getEmail().contains("@")) {
+//                //System.out.println(vraboten);
+//                this.vrabotenRepository.save(vraboten);
+//            }
+//            else{
+//                throw new IllegalStateException("email not valid");
+//            }
+//        }
+//        return vrabotenOpt;
     }
 
     @Transactional
-    public Vraboten updateVraboten(int vrabotenId, String firstName, String lastName, String mobile, String email, String status) {
+    public Vraboten updateVraboten(int vrabotenId,String password,String confirmPass,boolean locked, String firstName, String lastName, String mobile, String email, EmployeeStatus status,List<String> parkingZones) {
         Optional<Vraboten> vrabotenOpt = Optional.ofNullable(this.vrabotenRepository.findByVrabotenId(vrabotenId));
         if (vrabotenOpt.isPresent()) {
-            Vraboten vrabotenNov = this.vrabotenRepository.findByVrabotenId(vrabotenId);
-            if (email != null && email.length() > 1 && email.contains("@") && !Objects.equals(vrabotenNov.getEmail(), email)) {
-                Optional<Vraboten> userOpt1 = this.vrabotenRepository.findVrabotenByEmail(email);
-                if (userOpt1.isPresent()) {
+
+            if (email != null && email.length() > 1 && email.contains("@") ) {
+                List<String> emails = vrabotenRepository.findAll().stream().map(Vraboten::getEmail).collect(Collectors.toList());
+                for(String mailToCheck :emails)
+                if (email.equals(mailToCheck)&&vrabotenOpt.get().getVrabotenId()!=vrabotenId) {
                     throw new IllegalStateException("email taken");
                 }
-                vrabotenNov.setEmail(email);
+                vrabotenOpt.get().setEmail(email);
             } else {
                 throw new IllegalStateException("email not valid");
             }
-
-            if (firstName != null && firstName.length() > 1 && !Objects.equals(vrabotenNov.getFirstName(), firstName)) {
-                vrabotenNov.setFirstName(firstName);
-            }
-
-            if (lastName != null && lastName.length() > 1 && !Objects.equals(vrabotenNov.getLastName(), lastName)) {
-                vrabotenNov.setLastName(lastName);
-            }
-
-            if (mobile != null && mobile.length() > 0 && !Objects.equals(vrabotenNov.getMobile(), mobile)) {
-                vrabotenNov.setMobile(mobile);
-            }
-
-            if (mobile != null && status.length() > 0 && !Objects.equals(vrabotenNov.getStatus(), status)) {
-                if(status.equals("raboti") || status.equals("ne raboti") || status.equals("na odmor") || status.equals("na boleduvanje")){
-                    vrabotenNov.setStatus(status);
-                }else{
-                    throw new IllegalStateException("Please enter one of the following statuses: 'raboti', 'ne raboti', 'na odmor', 'na boleduvanje'");
+            if(password.equals(confirmPass)){
+                vrabotenOpt.get().setPassword(bCryptPasswordEncoder.encode(password));
+            }
+            vrabotenOpt.get().setLocked(locked);
+
+            if (firstName != null && firstName.length() > 1 && !Objects.equals(vrabotenOpt.get().getFirstName(), firstName)) {
+                vrabotenOpt.get().setFirstName(firstName);
+            }
+
+            if (lastName != null && lastName.length() > 1 && !Objects.equals(vrabotenOpt.get().getLastName(), lastName)) {
+                vrabotenOpt.get().setLastName(lastName);
+            }
+
+            if (mobile != null && mobile.length() > 0 && !Objects.equals(vrabotenOpt.get().getMobile(), mobile)) {
+                vrabotenOpt.get().setMobile(mobile);
+            }
+
+//            if (status != null && status.toString().length() > 0) {
+//                if(Arrays.stream(EmployeeStatus.values()).toList().contains(EmployeeStatus.valueOf(status))){
+            vrabotenOpt.get().setStatus(status);
+//                }else{
+//                    throw new IllegalStateException("Please enter one of the following statuses: 'raboti', 'ne raboti', 'na odmor', 'na boleduvanje'");
+//                }
+//            }
+            if(parkingZones!=null){
+                List<ParkingZone> parkingZonesAvailable =parkingZoneRepository.findAll();
+                List<ParkingZone> zonesToAdd= new ArrayList<>();
+                vrabotenOpt.get().setParkingZones(null);
+                for(String pzName:parkingZones){
+                    for(ParkingZone pz :parkingZonesAvailable){
+                        if(pzName.equals(pz.getPzName())) {
+                            zonesToAdd.add(pz);
+//                            pz.getOdgovorniLica().add(vrabotenRepository.findByVrabotenId(vrabotenId));
+                        }
+                    }
                 }
-            }
-
-            return vrabotenNov;
+                vrabotenOpt.get().setParkingZones(zonesToAdd);
+            }
+            return vrabotenOpt.get();
         }
         else{
@@ -107,10 +184,8 @@
     }//za menjanje password da se implementira
 
-    @Modifying
     @Transactional
     public Optional<Vraboten> deleteVraboten(int vrabotenId) {
         Optional<Vraboten> vrabotenOpt = Optional.ofNullable(this.vrabotenRepository.findByVrabotenId(vrabotenId));
         if (vrabotenOpt.isPresent()) {
-            //TODO da povikamo metod od ConfirmationTokenService za brisenje na ConfirmationTokenW
             this.confirmationTokenService.deleteByVraboten_VrabotenId(vrabotenId);
             this.vrabotenRepository.deleteByVrabotenId(vrabotenId);
@@ -129,5 +204,5 @@
             throw new IllegalStateException("Vraboten doesn't exist, therefore his account can't be locked/unlocked");
         }
-    }//dali treba da stoi @Transactional gore nad funkcijata?
+    }
 
     @Override
@@ -176,3 +251,13 @@
     }
 
+//    @Transactional
+//    public void setVrabotenStatus(int vrabotenId,String vrabotenStatus) {
+//        Vraboten vraboten = vrabotenRepository.findByVrabotenId(vrabotenId);
+//        if(vraboten!=null && value){
+//            vraboten.setStatus(valuee);
+//        }
+//        else {
+//            throw new IllegalStateException(String.format("Vraboten with id %d does not exist.",vrabotenId));
+//        }
+//    }
 }
